int Touch = 8;
int LED = 13;
int Mg1 = 23;
int Mg2 = 2;
int Buzzer = 7;

//para el ultrasonico
long tiempo;
int disparador = 3;   // triger
int entrada = 4;      // echo
float distancia;

//fotorresistencia
int Fr = A5;
int ValorFr = 0;

//Obstaculos
int buttonpin = 22; // define the obstacle avoidance sensor interface
int val ;// define numeric variables val

//Llaves
bool Llave1 = false;
bool Llave2 = false;
bool Llave3 = false;
bool Llave4 = false;
bool Llave5 = false;

bool LlaveAdicional = false;

//para reporte
int Primero = 0;
int Segundo = 0;
int Tercero = 0;
int Cuarto = 0;
int Quinto = 0;
int Sexto = 0;

void setup() {
  // put your setup code here, to run once:
  pinMode(Touch , INPUT);
  pinMode(Mg1 , INPUT);
  pinMode(Mg2 , INPUT);
  pinMode(LED , OUTPUT);
  pinMode(Buzzer, OUTPUT);

  //ultrasonico
  pinMode(disparador, OUTPUT);
  pinMode(entrada, INPUT);

  //obstaculos
  pinMode (buttonpin , INPUT) ;


  Serial.begin(9600);

  //sonidoPiratas();
}

void loop() {

  ultrasonico();

  if (Llave1) {
    Tactil();
  }

  if (Llave1 && Llave2) {

    digitalWrite(LED, HIGH);
    fotorresistencia();

  }

  if (Llave1 && Llave2 && Llave3) {

    Obstaculos();

  }

  if (Llave1 && Llave2 && Llave3 && Llave4) {

    Magnetico(Mg1);

  }

  if (Llave1 && Llave2 && Llave3 && Llave4 && Llave5) {

    Magnetico(Mg2);

  }
  String Cadena = "" ;
  //+ Segundo + "," +Tercero + "," + Cuarto + "," + Quinto+ "," + Sexto + ",";
  Serial.println(Cadena + Primero + "," + Segundo + "," + Tercero + "," + Cuarto + "," + Quinto + "," + Sexto + ",");

  if (Sexto == 1 && LlaveAdicional) {

    sonidoPiratas();
    LlaveAdicional = false;
    Primero = 0;
    Segundo = 0;
    Tercero = 0;
    Cuarto = 0;
    Quinto = 0;
    Sexto = 0;
  }
}


void Magnetico(int Mg) {

  int Iman = !digitalRead(Mg);

  if (Iman) {

    if (Llave5) {

      Sexto = 1;

      Llave1 = false;
      Llave2 = false;
      Llave3 = false;
      Llave4 = false;
      Llave5 = false;

      LlaveAdicional = true;

      digitalWrite(LED, LOW);


    } else {
      sonido();

      Quinto = 1;
      Llave5 = true;
    }
  }
}

void Tactil() {
  int Toco = digitalRead(Touch);


  if (Toco) {
    sonido();

    Segundo = 1;
    Llave2 = true;
  }
}

void Obstaculos() {
  val = digitalRead (buttonpin) ;// digital interface will be assigned a value of 3 to read val
  if (!val == HIGH) // When the obstacle avoidance sensor detects a signal, LED flashes
  {
    sonido();

    Cuarto = 1;
    Llave4 = true;
  }
  else
  {
    digitalWrite (Buzzer, LOW);
  }

  //Serial.println(val);
}

void fotorresistencia() {
  ValorFr = analogRead (Fr);
  if (ValorFr < 200) {
    sonido();

    Tercero = 1;
    Llave3 = true;

  } else {
    digitalWrite (Buzzer, LOW) ;
  };
  //Serial.println(ValorFr);
}

void ultrasonico() {
  // lanzamos un pequeño pulso para activar el sensor
  digitalWrite(disparador, HIGH);
  delayMicroseconds(10);
  digitalWrite(disparador, LOW);

  // medimos el pulso de respuesta
  tiempo = (pulseIn(entrada, HIGH) / 2);
  // dividido por 2 por que es el
  // tiempo que el sonido tarda
  // en ir y en volver
  // ahora calcularemos la distancia en cm
  // sabiendo que el espacio es igual a la velocidad por el tiempo
  // y que la velocidad del sonido es de 343m/s y que el tiempo lo
  // tenemos en millonesimas de segundo
  distancia = float(tiempo * 0.0343);

  if (distancia < 10 && distancia > 5) {
    //accion
    Primero = 1;
    Llave1 = true;

  } else {
    /*contraaccion */ ;
  }
  //Serial.println(distancia, 0); //sin decimales (0)
}

void sonido() {
  int i;
  for (i = 0; i < 80; i++) // Wen a frequency sound
  {
    digitalWrite (Buzzer, HIGH) ;// send voice
    delay (1) ;// Delay 1ms
    digitalWrite (Buzzer, LOW) ;// do not send voice
    delay (1) ;// delay ms
  }
  for (i = 0; i < 100; i++) // Wen Qie out another frequency sound
  {
    digitalWrite (Buzzer, HIGH) ;// send voice
    delay (2) ;// delay 2ms
    digitalWrite (Buzzer, LOW) ;// do not send voice
    delay (2) ;// delay 2ms
  }
}

void sonidoPiratas() {
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 200);
  delay(200);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 293.66, 100);
  delay(100);
  tone(Buzzer, 440, 100);
  delay(100);
  tone(Buzzer, 523.25, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 659.25, 100);
  delay(100);
  tone(Buzzer, 698.45, 100);
  delay(200);
  tone(Buzzer, 698.45, 100);
  delay(200);
  tone(Buzzer, 698.45, 100);
  delay(100);
  tone(Buzzer, 783.99, 100);
  delay(100);
  tone(Buzzer, 659.25, 100);
  delay(200);
  tone(Buzzer, 659.25, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 523.25, 100);
  delay(100);
  tone(Buzzer, 523.25, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(300);
  tone(Buzzer, 440, 100);
  delay(100);
  tone(Buzzer, 523.25, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 659.25, 100);
  delay(100);
  tone(Buzzer, 698.45, 100);
  delay(200);
  tone(Buzzer, 698.45, 100);
  delay(200);
  tone(Buzzer, 698.45, 100);
  delay(100);
  tone(Buzzer, 783.99, 100);
  delay(100);
  tone(Buzzer, 659.25, 100);
  delay(200);
  tone(Buzzer, 659.25, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 523.25, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(400);
  tone(Buzzer, 440, 100);
  delay(100);
  tone(Buzzer, 523.25, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 698.45, 100);
  delay(100);
  tone(Buzzer, 783.99, 100);
  delay(200);
  tone(Buzzer, 783.99, 100);
  delay(200);
  tone(Buzzer, 783.99, 100);
  delay(100);
  tone(Buzzer, 880, 100);
  delay(100);
  tone(Buzzer, 932.33, 100);
  delay(200);
  tone(Buzzer, 932.33, 100);
  delay(200);
  tone(Buzzer, 880, 100);
  delay(100);
  tone(Buzzer, 783.99, 100);
  delay(100);
  tone(Buzzer, 880, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(300);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 659.25, 100);
  delay(100);
  tone(Buzzer, 698.45, 100);
  delay(200);
  tone(Buzzer, 698.45, 100);
  delay(200);
  tone(Buzzer, 783.99, 100);
  delay(200);
  tone(Buzzer, 880, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(300);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 698.45, 100);
  delay(100);
  tone(Buzzer, 659.25, 100);
  delay(200);
  tone(Buzzer, 659.25, 100);
  delay(200);
  tone(Buzzer, 698.45, 100);
  delay(100);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 659.25, 100);
  delay(400);
  tone(Buzzer, 880, 100);
  delay(100);
  tone(Buzzer, 1046.50, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1318.51, 100);
  delay(100);
  tone(Buzzer, 1396.91, 100);
  delay(200);
  tone(Buzzer, 1396.91, 100);
  delay(200);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1567.98, 100);
  delay(100);
  tone(Buzzer, 1318.51, 100);
  delay(200);
  tone(Buzzer, 1318.51, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1046.50, 100);
  delay(100);
  tone(Buzzer, 1046.50, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(300);
  tone(Buzzer, 880, 100);
  delay(100);
  tone(Buzzer, 1046.50, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1318.51, 100);
  delay(100);
  tone(Buzzer, 1396.91, 100);
  delay(200);
  tone(Buzzer, 1396.91, 100);
  delay(200);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1567.98, 100);
  delay(100);
  tone(Buzzer, 1318.51, 100);
  delay(200);
  tone(Buzzer, 1318.51, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1046.50, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(400);
  tone(Buzzer, 880, 100);
  delay(100);
  tone(Buzzer, 1046.50, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1567.98, 100);
  delay(200);
  tone(Buzzer, 1567.98, 100);
  delay(200);
  tone(Buzzer, 1567.98, 100);
  delay(100);
  tone(Buzzer, 1760, 100);
  delay(100);
  tone(Buzzer, 1864.66, 100);
  delay(200);
  tone(Buzzer, 1864.66, 100);
  delay(200);
  tone(Buzzer, 1760, 100);
  delay(100);
  tone(Buzzer, 1567.98, 100);
  delay(100);
  tone(Buzzer, 1760, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(300);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1318.51, 100);
  delay(100);
  tone(Buzzer, 1396.91, 100);
  delay(200);
  tone(Buzzer, 1396.91, 100);
  delay(200);
  tone(Buzzer, 1567.98, 100);
  delay(200);
  tone(Buzzer, 1760, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(300);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1318.51, 100);
  delay(200);
  tone(Buzzer, 1318.51, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 1108.73, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1174.66, 100);
  delay(200);
  tone(Buzzer, 1318.51, 100);
  delay(200);
  tone(Buzzer, 1396.91, 100);
  delay(200);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1567.98, 100);
  delay(200);
  tone(Buzzer, 1760, 200);
  delay(400);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 880, 200);
  delay(600);
  tone(Buzzer, 1864.66, 200);
  delay(400);
  tone(Buzzer, 1396.91, 100);
  delay(100);
  tone(Buzzer, 1174.66, 100);
  delay(100);
  tone(Buzzer, 932.33, 200);
  delay(600);
  tone(Buzzer, 587.33, 100);
  delay(100);
  tone(Buzzer, 440, 100);
  delay(200);
  tone(Buzzer, 587.33, 100);
  delay(300);
  tone(Buzzer, 554.36, 100);
  delay(400);
  tone(Buzzer, 1567.98, 100);
  delay(100);
  tone(Buzzer, 1567.98, 100);
  delay(100);
}
